Code

do not overwrite untracked during merge from unborn branch
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22         # do not redirect again
23         ;;
24 *' --tee '*|*' --va'*)
25         mkdir -p test-results
26         BASE=test-results/$(basename "$0" .sh)
27         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28          echo $? > $BASE.exit) | tee $BASE.out
29         test "$(cat $BASE.exit)" = 0
30         exit
31         ;;
32 esac
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 EDITOR=:
45 unset VISUAL
46 unset GIT_EDITOR
47 unset AUTHOR_DATE
48 unset AUTHOR_EMAIL
49 unset AUTHOR_NAME
50 unset COMMIT_AUTHOR_EMAIL
51 unset COMMIT_AUTHOR_NAME
52 unset EMAIL
53 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
54 unset GIT_AUTHOR_DATE
55 GIT_AUTHOR_EMAIL=author@example.com
56 GIT_AUTHOR_NAME='A U Thor'
57 unset GIT_COMMITTER_DATE
58 GIT_COMMITTER_EMAIL=committer@example.com
59 GIT_COMMITTER_NAME='C O Mitter'
60 unset GIT_DIFF_OPTS
61 unset GIT_DIR
62 unset GIT_WORK_TREE
63 unset GIT_EXTERNAL_DIFF
64 unset GIT_INDEX_FILE
65 unset GIT_OBJECT_DIRECTORY
66 unset GIT_CEILING_DIRECTORIES
67 unset SHA1_FILE_DIRECTORIES
68 unset SHA1_FILE_DIRECTORY
69 unset GIT_NOTES_REF
70 unset GIT_NOTES_DISPLAY_REF
71 unset GIT_NOTES_REWRITE_REF
72 unset GIT_NOTES_REWRITE_MODE
73 GIT_MERGE_VERBOSITY=5
74 export GIT_MERGE_VERBOSITY
75 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
76 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
77 export EDITOR
79 # Protect ourselves from common misconfiguration to export
80 # CDPATH into the environment
81 unset CDPATH
83 unset GREP_OPTIONS
85 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
86         1|2|true)
87                 echo "* warning: Some tests will not work if GIT_TRACE" \
88                         "is set as to trace on STDERR ! *"
89                 echo "* warning: Please set GIT_TRACE to something" \
90                         "other than 1, 2 or true ! *"
91                 ;;
92 esac
94 # Convenience
95 #
96 # A regexp to match 5 and 40 hexdigits
97 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
98 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
100 # Each test should start with something like this, after copyright notices:
102 # test_description='Description of this test...
103 # This test checks if command xyzzy does the right thing...
104 # '
105 # . ./test-lib.sh
106 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
107                 TERM=$ORIGINAL_TERM &&
108                 export TERM &&
109                 [ -t 1 ] &&
110                 tput bold >/dev/null 2>&1 &&
111                 tput setaf 1 >/dev/null 2>&1 &&
112                 tput sgr0 >/dev/null 2>&1
113         ) &&
114         color=t
116 while test "$#" -ne 0
117 do
118         case "$1" in
119         -d|--d|--de|--deb|--debu|--debug)
120                 debug=t; shift ;;
121         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
122                 immediate=t; shift ;;
123         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
124                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
125         -h|--h|--he|--hel|--help)
126                 help=t; shift ;;
127         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
128                 verbose=t; shift ;;
129         -q|--q|--qu|--qui|--quie|--quiet)
130                 quiet=t; shift ;;
131         --with-dashes)
132                 with_dashes=t; shift ;;
133         --no-color)
134                 color=; shift ;;
135         --no-python)
136                 # noop now...
137                 shift ;;
138         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
139                 valgrind=t; verbose=t; shift ;;
140         --tee)
141                 shift ;; # was handled already
142         --root=*)
143                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
144                 shift ;;
145         *)
146                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
147         esac
148 done
150 if test -n "$color"; then
151         say_color () {
152                 (
153                 TERM=$ORIGINAL_TERM
154                 export TERM
155                 case "$1" in
156                         error) tput bold; tput setaf 1;; # bold red
157                         skip)  tput bold; tput setaf 2;; # bold green
158                         pass)  tput setaf 2;;            # green
159                         info)  tput setaf 3;;            # brown
160                         *) test -n "$quiet" && return;;
161                 esac
162                 shift
163                 printf "%s" "$*"
164                 tput sgr0
165                 echo
166                 )
167         }
168 else
169         say_color() {
170                 test -z "$1" && test -n "$quiet" && return
171                 shift
172                 echo "$*"
173         }
174 fi
176 error () {
177         say_color error "error: $*"
178         GIT_EXIT_OK=t
179         exit 1
182 say () {
183         say_color info "$*"
186 test "${test_description}" != "" ||
187 error "Test script did not set test_description."
189 if test "$help" = "t"
190 then
191         echo "$test_description"
192         exit 0
193 fi
195 exec 5>&1
196 if test "$verbose" = "t"
197 then
198         exec 4>&2 3>&1
199 else
200         exec 4>/dev/null 3>/dev/null
201 fi
203 test_failure=0
204 test_count=0
205 test_fixed=0
206 test_broken=0
207 test_success=0
209 test_external_has_tap=0
211 die () {
212         code=$?
213         if test -n "$GIT_EXIT_OK"
214         then
215                 exit $code
216         else
217                 echo >&5 "FATAL: Unexpected exit with code $code"
218                 exit 1
219         fi
222 GIT_EXIT_OK=
223 trap 'die' EXIT
225 # The semantics of the editor variables are that of invoking
226 # sh -c "$EDITOR \"$@\"" files ...
228 # If our trash directory contains shell metacharacters, they will be
229 # interpreted if we just set $EDITOR directly, so do a little dance with
230 # environment variables to work around this.
232 # In particular, quoting isn't enough, as the path may contain the same quote
233 # that we're using.
234 test_set_editor () {
235         FAKE_EDITOR="$1"
236         export FAKE_EDITOR
237         EDITOR='"$FAKE_EDITOR"'
238         export EDITOR
241 test_decode_color () {
242         sed     -e 's/.\[1m/<WHITE>/g' \
243                 -e 's/.\[31m/<RED>/g' \
244                 -e 's/.\[32m/<GREEN>/g' \
245                 -e 's/.\[33m/<YELLOW>/g' \
246                 -e 's/.\[34m/<BLUE>/g' \
247                 -e 's/.\[35m/<MAGENTA>/g' \
248                 -e 's/.\[36m/<CYAN>/g' \
249                 -e 's/.\[m/<RESET>/g'
252 q_to_nul () {
253         perl -pe 'y/Q/\000/'
256 q_to_cr () {
257         tr Q '\015'
260 append_cr () {
261         sed -e 's/$/Q/' | tr Q '\015'
264 remove_cr () {
265         tr '\015' Q | sed -e 's/Q$//'
268 test_tick () {
269         if test -z "${test_tick+set}"
270         then
271                 test_tick=1112911993
272         else
273                 test_tick=$(($test_tick + 60))
274         fi
275         GIT_COMMITTER_DATE="$test_tick -0700"
276         GIT_AUTHOR_DATE="$test_tick -0700"
277         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
280 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
282 # This will commit a file with the given contents and the given commit
283 # message.  It will also add a tag with <message> as name.
285 # Both <file> and <contents> default to <message>.
287 test_commit () {
288         file=${2:-"$1.t"}
289         echo "${3-$1}" > "$file" &&
290         git add "$file" &&
291         test_tick &&
292         git commit -m "$1" &&
293         git tag "$1"
296 # Call test_merge with the arguments "<message> <commit>", where <commit>
297 # can be a tag pointing to the commit-to-merge.
299 test_merge () {
300         test_tick &&
301         git merge -m "$1" "$2" &&
302         git tag "$1"
305 # This function helps systems where core.filemode=false is set.
306 # Use it instead of plain 'chmod +x' to set or unset the executable bit
307 # of a file in the working directory and add it to the index.
309 test_chmod () {
310         chmod "$@" &&
311         git update-index --add "--chmod=$@"
314 # Use test_set_prereq to tell that a particular prerequisite is available.
315 # The prerequisite can later be checked for in two ways:
317 # - Explicitly using test_have_prereq.
319 # - Implicitly by specifying the prerequisite tag in the calls to
320 #   test_expect_{success,failure,code}.
322 # The single parameter is the prerequisite tag (a simple word, in all
323 # capital letters by convention).
325 test_set_prereq () {
326         satisfied="$satisfied$1 "
328 satisfied=" "
330 test_have_prereq () {
331         case $satisfied in
332         *" $1 "*)
333                 : yes, have it ;;
334         *)
335                 ! : nope ;;
336         esac
339 # You are not expected to call test_ok_ and test_failure_ directly, use
340 # the text_expect_* functions instead.
342 test_ok_ () {
343         test_success=$(($test_success + 1))
344         say_color "" "ok $test_count - $@"
347 test_failure_ () {
348         test_failure=$(($test_failure + 1))
349         say_color error "not ok - $test_count $1"
350         shift
351         echo "$@" | sed -e 's/^/#       /'
352         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
355 test_known_broken_ok_ () {
356         test_fixed=$(($test_fixed+1))
357         say_color "" "ok $test_count - $@ # TODO known breakage"
360 test_known_broken_failure_ () {
361         test_broken=$(($test_broken+1))
362         say_color skip "not ok $test_count - $@ # TODO known breakage"
365 test_debug () {
366         test "$debug" = "" || eval "$1"
369 test_run_ () {
370         test_cleanup=:
371         eval >&3 2>&4 "$1"
372         eval_ret=$?
373         eval >&3 2>&4 "$test_cleanup"
374         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
375                 echo ""
376         fi
377         return 0
380 test_skip () {
381         test_count=$(($test_count+1))
382         to_skip=
383         for skp in $GIT_SKIP_TESTS
384         do
385                 case $this_test.$test_count in
386                 $skp)
387                         to_skip=t
388                         break
389                 esac
390         done
391         if test -z "$to_skip" && test -n "$prereq" &&
392            ! test_have_prereq "$prereq"
393         then
394                 to_skip=t
395         fi
396         case "$to_skip" in
397         t)
398                 say_color skip >&3 "skipping test: $@"
399                 say_color skip "ok $test_count # skip $1"
400                 : true
401                 ;;
402         *)
403                 false
404                 ;;
405         esac
408 test_expect_failure () {
409         test "$#" = 3 && { prereq=$1; shift; } || prereq=
410         test "$#" = 2 ||
411         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
412         if ! test_skip "$@"
413         then
414                 say >&3 "checking known breakage: $2"
415                 test_run_ "$2"
416                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
417                 then
418                         test_known_broken_ok_ "$1"
419                 else
420                         test_known_broken_failure_ "$1"
421                 fi
422         fi
423         echo >&3 ""
426 test_expect_success () {
427         test "$#" = 3 && { prereq=$1; shift; } || prereq=
428         test "$#" = 2 ||
429         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
430         if ! test_skip "$@"
431         then
432                 say >&3 "expecting success: $2"
433                 test_run_ "$2"
434                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
435                 then
436                         test_ok_ "$1"
437                 else
438                         test_failure_ "$@"
439                 fi
440         fi
441         echo >&3 ""
444 test_expect_code () {
445         test "$#" = 4 && { prereq=$1; shift; } || prereq=
446         test "$#" = 3 ||
447         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
448         if ! test_skip "$@"
449         then
450                 say >&3 "expecting exit code $1: $3"
451                 test_run_ "$3"
452                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
453                 then
454                         test_ok_ "$2"
455                 else
456                         test_failure_ "$@"
457                 fi
458         fi
459         echo >&3 ""
462 # test_external runs external test scripts that provide continuous
463 # test output about their progress, and succeeds/fails on
464 # zero/non-zero exit code.  It outputs the test output on stdout even
465 # in non-verbose mode, and announces the external script with "# run
466 # <n>: ..." before running it.  When providing relative paths, keep in
467 # mind that all scripts run in "trash directory".
468 # Usage: test_external description command arguments...
469 # Example: test_external 'Perl API' perl ../path/to/test.pl
470 test_external () {
471         test "$#" = 4 && { prereq=$1; shift; } || prereq=
472         test "$#" = 3 ||
473         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
474         descr="$1"
475         shift
476         if ! test_skip "$descr" "$@"
477         then
478                 # Announce the script to reduce confusion about the
479                 # test output that follows.
480                 say_color "" "# run $test_count: $descr ($*)"
481                 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
482                 # to be able to use them in script
483                 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
484                 # Run command; redirect its stderr to &4 as in
485                 # test_run_, but keep its stdout on our stdout even in
486                 # non-verbose mode.
487                 "$@" 2>&4
488                 if [ "$?" = 0 ]
489                 then
490                         if test $test_external_has_tap -eq 0; then
491                                 test_ok_ "$descr"
492                         else
493                                 say_color "" "# test_external test $descr was ok"
494                                 test_success=$(($test_success + 1))
495                         fi
496                 else
497                         if test $test_external_has_tap -eq 0; then
498                                 test_failure_ "$descr" "$@"
499                         else
500                                 say_color error "# test_external test $descr failed: $@"
501                                 test_failure=$(($test_failure + 1))
502                         fi
503                 fi
504         fi
507 # Like test_external, but in addition tests that the command generated
508 # no output on stderr.
509 test_external_without_stderr () {
510         # The temporary file has no (and must have no) security
511         # implications.
512         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
513         stderr="$tmp/git-external-stderr.$$.tmp"
514         test_external "$@" 4> "$stderr"
515         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
516         descr="no stderr: $1"
517         shift
518         say >&3 "# expecting no stderr from previous command"
519         if [ ! -s "$stderr" ]; then
520                 rm "$stderr"
522                 if test $test_external_has_tap -eq 0; then
523                         test_ok_ "$descr"
524                 else
525                         say_color "" "# test_external_without_stderr test $descr was ok"
526                         test_success=$(($test_success + 1))
527                 fi
528         else
529                 if [ "$verbose" = t ]; then
530                         output=`echo; echo "# Stderr is:"; cat "$stderr"`
531                 else
532                         output=
533                 fi
534                 # rm first in case test_failure exits.
535                 rm "$stderr"
536                 if test $test_external_has_tap -eq 0; then
537                         test_failure_ "$descr" "$@" "$output"
538                 else
539                         say_color error "# test_external_without_stderr test $descr failed: $@: $output"
540                         test_failure=$(($test_failure + 1))
541                 fi
542         fi
545 # debugging-friendly alternatives to "test [-f|-d|-e]"
546 # The commands test the existence or non-existence of $1. $2 can be
547 # given to provide a more precise diagnosis.
548 test_path_is_file () {
549         if ! [ -f "$1" ]
550         then
551                 echo "File $1 doesn't exist. $*"
552                 false
553         fi
556 test_path_is_dir () {
557         if ! [ -d "$1" ]
558         then
559                 echo "Directory $1 doesn't exist. $*"
560                 false
561         fi
564 test_path_is_missing () {
565         if [ -e "$1" ]
566         then
567                 echo "Path exists:"
568                 ls -ld "$1"
569                 if [ $# -ge 1 ]; then
570                         echo "$*"
571                 fi
572                 false
573         fi
577 # This is not among top-level (test_expect_success | test_expect_failure)
578 # but is a prefix that can be used in the test script, like:
580 #       test_expect_success 'complain and die' '
581 #           do something &&
582 #           do something else &&
583 #           test_must_fail git checkout ../outerspace
584 #       '
586 # Writing this as "! git checkout ../outerspace" is wrong, because
587 # the failure could be due to a segv.  We want a controlled failure.
589 test_must_fail () {
590         "$@"
591         test $? -gt 0 -a $? -le 129 -o $? -gt 192
594 # Similar to test_must_fail, but tolerates success, too.  This is
595 # meant to be used in contexts like:
597 #       test_expect_success 'some command works without configuration' '
598 #               test_might_fail git config --unset all.configuration &&
599 #               do something
600 #       '
602 # Writing "git config --unset all.configuration || :" would be wrong,
603 # because we want to notice if it fails due to segv.
605 test_might_fail () {
606         "$@"
607         test $? -ge 0 -a $? -le 129 -o $? -gt 192
610 # test_cmp is a helper function to compare actual and expected output.
611 # You can use it like:
613 #       test_expect_success 'foo works' '
614 #               echo expected >expected &&
615 #               foo >actual &&
616 #               test_cmp expected actual
617 #       '
619 # This could be written as either "cmp" or "diff -u", but:
620 # - cmp's output is not nearly as easy to read as diff -u
621 # - not all diff versions understand "-u"
623 test_cmp() {
624         $GIT_TEST_CMP "$@"
627 # This function can be used to schedule some commands to be run
628 # unconditionally at the end of the test to restore sanity:
630 #       test_expect_success 'test core.capslock' '
631 #               git config core.capslock true &&
632 #               test_when_finished "git config --unset core.capslock" &&
633 #               hello world
634 #       '
636 # That would be roughly equivalent to
638 #       test_expect_success 'test core.capslock' '
639 #               git config core.capslock true &&
640 #               hello world
641 #               git config --unset core.capslock
642 #       '
644 # except that the greeting and config --unset must both succeed for
645 # the test to pass.
647 test_when_finished () {
648         test_cleanup="{ $*
649                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
652 # Most tests can use the created repository, but some may need to create more.
653 # Usage: test_create_repo <directory>
654 test_create_repo () {
655         test "$#" = 1 ||
656         error "bug in the test script: not 1 parameter to test-create-repo"
657         owd=`pwd`
658         repo="$1"
659         mkdir -p "$repo"
660         cd "$repo" || error "Cannot setup test environment"
661         "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
662         error "cannot run git init -- have you built things yet?"
663         mv .git/hooks .git/hooks-disabled
664         cd "$owd"
667 test_done () {
668         GIT_EXIT_OK=t
669         test_results_dir="$TEST_DIRECTORY/test-results"
670         mkdir -p "$test_results_dir"
671         test_results_path="$test_results_dir/${0%.sh}-$$.counts"
673         echo "total $test_count" >> $test_results_path
674         echo "success $test_success" >> $test_results_path
675         echo "fixed $test_fixed" >> $test_results_path
676         echo "broken $test_broken" >> $test_results_path
677         echo "failed $test_failure" >> $test_results_path
678         echo "" >> $test_results_path
680         if test "$test_fixed" != 0
681         then
682                 say_color pass "# fixed $test_fixed known breakage(s)"
683         fi
684         if test "$test_broken" != 0
685         then
686                 say_color error "# still have $test_broken known breakage(s)"
687                 msg="remaining $(($test_count-$test_broken)) test(s)"
688         else
689                 msg="$test_count test(s)"
690         fi
691         case "$test_failure" in
692         0)
693                 # Maybe print SKIP message
694                 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
696                 if test $test_external_has_tap -eq 0; then
697                         say_color pass "# passed all $msg"
698                         say "1..$test_count$skip_all"
699                 fi
701                 test -d "$remove_trash" &&
702                 cd "$(dirname "$remove_trash")" &&
703                 rm -rf "$(basename "$remove_trash")"
705                 exit 0 ;;
707         *)
708                 if test $test_external_has_tap -eq 0; then
709                         say_color error "# failed $test_failure among $msg"
710                         say "1..$test_count"
711                 fi
713                 exit 1 ;;
715         esac
718 # Test the binaries we have just built.  The tests are kept in
719 # t/ subdirectory and are run in 'trash directory' subdirectory.
720 TEST_DIRECTORY=$(pwd)
721 if test -n "$valgrind"
722 then
723         make_symlink () {
724                 test -h "$2" &&
725                 test "$1" = "$(readlink "$2")" || {
726                         # be super paranoid
727                         if mkdir "$2".lock
728                         then
729                                 rm -f "$2" &&
730                                 ln -s "$1" "$2" &&
731                                 rm -r "$2".lock
732                         else
733                                 while test -d "$2".lock
734                                 do
735                                         say "Waiting for lock on $2."
736                                         sleep 1
737                                 done
738                         fi
739                 }
740         }
742         make_valgrind_symlink () {
743                 # handle only executables
744                 test -x "$1" || return
746                 base=$(basename "$1")
747                 symlink_target=$TEST_DIRECTORY/../$base
748                 # do not override scripts
749                 if test -x "$symlink_target" &&
750                     test ! -d "$symlink_target" &&
751                     test "#!" != "$(head -c 2 < "$symlink_target")"
752                 then
753                         symlink_target=../valgrind.sh
754                 fi
755                 case "$base" in
756                 *.sh|*.perl)
757                         symlink_target=../unprocessed-script
758                 esac
759                 # create the link, or replace it if it is out of date
760                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
761         }
763         # override all git executables in TEST_DIRECTORY/..
764         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
765         mkdir -p "$GIT_VALGRIND"/bin
766         for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
767         do
768                 make_valgrind_symlink $file
769         done
770         OLDIFS=$IFS
771         IFS=:
772         for path in $PATH
773         do
774                 ls "$path"/git-* 2> /dev/null |
775                 while read file
776                 do
777                         make_valgrind_symlink "$file"
778                 done
779         done
780         IFS=$OLDIFS
781         PATH=$GIT_VALGRIND/bin:$PATH
782         GIT_EXEC_PATH=$GIT_VALGRIND/bin
783         export GIT_VALGRIND
784 elif test -n "$GIT_TEST_INSTALLED" ; then
785         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
786         error "Cannot run git from $GIT_TEST_INSTALLED."
787         PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
788         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
789 else # normal case, use ../bin-wrappers only unless $with_dashes:
790         git_bin_dir="$TEST_DIRECTORY/../bin-wrappers"
791         if ! test -x "$git_bin_dir/git" ; then
792                 if test -z "$with_dashes" ; then
793                         say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
794                 fi
795                 with_dashes=t
796         fi
797         PATH="$git_bin_dir:$PATH"
798         GIT_EXEC_PATH=$TEST_DIRECTORY/..
799         if test -n "$with_dashes" ; then
800                 PATH="$TEST_DIRECTORY/..:$PATH"
801         fi
802 fi
803 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
804 unset GIT_CONFIG
805 GIT_CONFIG_NOSYSTEM=1
806 GIT_CONFIG_NOGLOBAL=1
807 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
809 . ../GIT-BUILD-OPTIONS
811 if test -z "$GIT_TEST_CMP"
812 then
813         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
814         then
815                 GIT_TEST_CMP="$DIFF -c"
816         else
817                 GIT_TEST_CMP="$DIFF -u"
818         fi
819 fi
821 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
822 export GITPERLLIB
823 test -d ../templates/blt || {
824         error "You haven't built things yet, have you?"
827 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
828 then
829         GITPYTHONLIB="$(pwd)/../git_remote_helpers/build/lib"
830         export GITPYTHONLIB
831         test -d ../git_remote_helpers/build || {
832                 error "You haven't built git_remote_helpers yet, have you?"
833         }
834 fi
836 if ! test -x ../test-chmtime; then
837         echo >&2 'You need to build test-chmtime:'
838         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
839         exit 1
840 fi
842 # Test repository
843 test="trash directory.$(basename "$0" .sh)"
844 test -n "$root" && test="$root/$test"
845 case "$test" in
846 /*) TRASH_DIRECTORY="$test" ;;
847  *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
848 esac
849 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
850 rm -fr "$test" || {
851         GIT_EXIT_OK=t
852         echo >&5 "FATAL: Cannot prepare test area"
853         exit 1
856 test_create_repo "$test"
857 # Use -P to resolve symlinks in our working directory so that the cwd
858 # in subprocesses like git equals our $PWD (for pathname comparisons).
859 cd -P "$test" || exit 1
861 this_test=${0##*/}
862 this_test=${this_test%%-*}
863 for skp in $GIT_SKIP_TESTS
864 do
865         case "$this_test" in
866         $skp)
867                 say_color skip >&3 "skipping test $this_test altogether"
868                 skip_all="skip all tests in $this_test"
869                 test_done
870         esac
871 done
873 # Provide an implementation of the 'yes' utility
874 yes () {
875         if test $# = 0
876         then
877                 y=y
878         else
879                 y="$*"
880         fi
882         while echo "$y"
883         do
884                 :
885         done
888 # Fix some commands on Windows
889 case $(uname -s) in
890 *MINGW*)
891         # Windows has its own (incompatible) sort and find
892         sort () {
893                 /usr/bin/sort "$@"
894         }
895         find () {
896                 /usr/bin/find "$@"
897         }
898         sum () {
899                 md5sum "$@"
900         }
901         # git sees Windows-style pwd
902         pwd () {
903                 builtin pwd -W
904         }
905         # no POSIX permissions
906         # backslashes in pathspec are converted to '/'
907         # exec does not inherit the PID
908         ;;
909 *)
910         test_set_prereq POSIXPERM
911         test_set_prereq BSLASHPSPEC
912         test_set_prereq EXECKEEPSPID
913         ;;
914 esac
916 test -z "$NO_PERL" && test_set_prereq PERL
917 test -z "$NO_PYTHON" && test_set_prereq PYTHON
919 # test whether the filesystem supports symbolic links
920 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
921 rm -f y